/* LabelWithWidgets.c generated by valac 0.56.14, the Vala compiler
 * generated from LabelWithWidgets.vala, do not modify */

/* LabelWithWidgets is ported from Fractal*/
/* https://gitlab.gnome.org/GNOME/fractal/-/blob/3f8a7e8bd06441d83a5f052a2ae68d7d228dfcd0/src/components/label_with_widgets.rs*/
/* How to use:*/
/* Set `text` to the label's content but use the `placeholder` keyword where widgets should be placed.*/
/* Then use `set_children` with an array of Widgets in order of how they should be placed in the label.*/
/* There are some helper functions like `append_child` to add children and*/
/* `LabelWithWidgets.with_label_and_widgets` to construct it with the desired text and widgets.*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER "\xEF\xBF\xBC"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS (tuba_widgets_label_with_widgets_get_type ())
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))

typedef struct _TubaWidgetsLabelWithWidgets TubaWidgetsLabelWithWidgets;
typedef struct _TubaWidgetsLabelWithWidgetsClass TubaWidgetsLabelWithWidgetsClass;
typedef struct _TubaWidgetsLabelWithWidgetsPrivate TubaWidgetsLabelWithWidgetsPrivate;

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_TYPE_LWW_WIDGET (tuba_widgets_label_with_widgets_lww_widget_get_type ())
typedef struct _TubaWidgetsLabelWithWidgetsLWWWidget TubaWidgetsLabelWithWidgetsLWWWidget;
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_0_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES
};
static GParamSpec* tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define __vala_PangoLayoutRun_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutRun_free (var), NULL)))
#define __vala_PangoLayoutIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutIter_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS
};
static guint tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS] = {0};

struct _TubaWidgetsLabelWithWidgets {
	GtkWidget parent_instance;
	TubaWidgetsLabelWithWidgetsPrivate * priv;
	GtkLabel* label;
};

struct _TubaWidgetsLabelWithWidgetsClass {
	GtkWidgetClass parent_class;
};

struct _TubaWidgetsLabelWithWidgetsLWWWidget {
	GtkWidget* widget;
	gint height;
	gint width;
};

struct _TubaWidgetsLabelWithWidgetsPrivate {
	TubaWidgetsLabelWithWidgetsLWWWidget* widgets;
	gint widgets_length1;
	gint _widgets_size_;
	gchar* _placeholder;
	gchar* _label_text;
	gchar* _text;
	gboolean _use_markup;
};

static gint TubaWidgetsLabelWithWidgets_private_offset;
static gpointer tuba_widgets_label_with_widgets_parent_class = NULL;
static GtkBuildableIface * tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = NULL;
static GtkAccessibleInterface * tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = NULL;

VALA_EXTERN GType tuba_widgets_label_with_widgets_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaWidgetsLabelWithWidgets, g_object_unref)
static GType tuba_widgets_label_with_widgets_lww_widget_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static TubaWidgetsLabelWithWidgetsLWWWidget* tuba_widgets_label_with_widgets_lww_widget_dup (const TubaWidgetsLabelWithWidgetsLWWWidget* self);
static void tuba_widgets_label_with_widgets_lww_widget_free (TubaWidgetsLabelWithWidgetsLWWWidget* self);
static void tuba_widgets_label_with_widgets_lww_widget_copy (const TubaWidgetsLabelWithWidgetsLWWWidget* self,
                                                      TubaWidgetsLabelWithWidgetsLWWWidget* dest);
static void tuba_widgets_label_with_widgets_lww_widget_destroy (TubaWidgetsLabelWithWidgetsLWWWidget* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TubaWidgetsLabelWithWidgetsLWWWidget, tuba_widgets_label_with_widgets_lww_widget_destroy)
static void _vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (TubaWidgetsLabelWithWidgetsLWWWidget * array,
                                                            gssize array_length);
static void tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self);
static PangoLayoutRun* _vala_PangoLayoutRun_copy (PangoLayoutRun* self);
static gint tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                                   gint d,
                                                   gint a);
static void _vala_PangoLayoutRun_free (PangoLayoutRun* self);
static void _vala_PangoLayoutIter_free (PangoLayoutIter* self);
static void tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                         gint width,
                                                         gint height,
                                                         gint baseline);
static GtkSizeRequestMode tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base);
static void tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                                   GtkOrientation orientation,
                                                   gint for_size,
                                                   gint* minimum,
                                                   gint* natural,
                                                   gint* minimum_baseline,
                                                   gint* natural_baseline);
static void tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget* child);
static void _vala_array_add26 (TubaWidgetsLabelWithWidgetsLWWWidget* * array,
                        gint* length,
                        gint* size,
                        const TubaWidgetsLabelWithWidgetsLWWWidget* value);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                                                         GtkWidget** t_widgets,
                                                                                         gint t_widgets_length1);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                                               const gchar* t_text,
                                                                                               GtkWidget** t_widgets,
                                                                                               gint t_widgets_length1);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                               const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget** t_widgets,
                                                   gint t_widgets_length1);
static void tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                     GtkBuilder* builder,
                                                     GObject* child,
                                                     const gchar* type);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new (void);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct (GType object_type);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                      const gchar* value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                           gboolean value);
VALA_EXTERN gfloat tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                                 gfloat value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gint tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                                gint value);
VALA_EXTERN GtkJustification tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                                  GtkJustification value);
static void g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * tuba_widgets_label_with_widgets_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static gboolean _tuba_widgets_label_with_widgets___lambda26_ (TubaWidgetsLabelWithWidgets* self,
                                                       const gchar* url);
static gboolean __tuba_widgets_label_with_widgets___lambda26__gtk_label_activate_link (GtkLabel* _sender,
                                                                                const gchar* uri,
                                                                                gpointer self);
static void tuba_widgets_label_with_widgets_finalize (GObject * obj);
static GType tuba_widgets_label_with_widgets_get_type_once (void);
static void _vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
tuba_widgets_label_with_widgets_get_instance_private (TubaWidgetsLabelWithWidgets* self)
{
	return G_STRUCT_MEMBER_P (self, TubaWidgetsLabelWithWidgets_private_offset);
}

static void
_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (TubaWidgetsLabelWithWidgetsLWWWidget * array,
                                                       gssize array_length)
{
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	if (array != NULL) {
#line 226 "LabelWithWidgets.c"
		gssize i;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 17 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_destroy (&array[i]);
#line 232 "LabelWithWidgets.c"
		}
	}
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	g_free (array);
#line 237 "LabelWithWidgets.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 261 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 269 "LabelWithWidgets.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 275 "LabelWithWidgets.c"
	}
}

static void
tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self)
{
	gboolean child_size_changed = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp2_;
	gint _tmp2__length1;
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp24_;
	gint index = 0;
	GtkLabel* _tmp50_;
	PangoAttrList* _tmp51_;
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Widgets/LabelWithWidgets.vala"
	child_size_changed = FALSE;
#line 84 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = tuba_widgets_label_with_widgets_get_text (self);
#line 84 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _tmp0_;
#line 84 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 84 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 304 "LabelWithWidgets.c"
	}
#line 85 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->priv->widgets;
#line 85 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2__length1 = self->priv->widgets_length1;
#line 85 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp2__length1 == 0) {
#line 312 "LabelWithWidgets.c"
		GtkLabel* _tmp3_;
#line 86 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = self->label;
#line 86 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_attributes (_tmp3_, NULL);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 320 "LabelWithWidgets.c"
	}
	{
		gint i = 0;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 326 "LabelWithWidgets.c"
		{
			gboolean _tmp4_ = FALSE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
			_tmp4_ = TRUE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 333 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp6_;
				gint _tmp6__length1;
				GtkRequisition size = {0};
				GtkRequisition natural_size = {0};
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp7_;
				gint _tmp7__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp8_;
				GtkWidget* _tmp9_;
				GtkRequisition _tmp10_ = {0};
				GtkRequisition _tmp11_ = {0};
				gint width = 0;
				GtkRequisition _tmp12_;
				gint height = 0;
				GtkRequisition _tmp13_;
				gint old_width = 0;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp14_;
				gint _tmp14__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp15_;
				gint old_height = 0;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp16_;
				gint _tmp16__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp17_;
				gboolean _tmp18_ = FALSE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp4_) {
#line 359 "LabelWithWidgets.c"
					gint _tmp5_;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					_tmp5_ = i;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp5_ + 1;
#line 365 "LabelWithWidgets.c"
				}
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = FALSE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = self->priv->widgets;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6__length1 = self->priv->widgets_length1;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp6__length1)) {
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 377 "LabelWithWidgets.c"
				}
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = self->priv->widgets;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7__length1 = self->priv->widgets_length1;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = _tmp7_[i];
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				_tmp9_ = _tmp8_.widget;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_get_preferred_size (_tmp9_, &_tmp10_, &_tmp11_);
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				size = _tmp10_;
#line 93 "../src/Widgets/LabelWithWidgets.vala"
				natural_size = _tmp11_;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp12_ = natural_size;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp12_.width;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
				_tmp13_ = natural_size;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp13_.height;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14_ = self->priv->widgets;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14__length1 = self->priv->widgets_length1;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15_ = _tmp14_[i];
#line 97 "../src/Widgets/LabelWithWidgets.vala"
				old_width = _tmp15_.width;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16_ = self->priv->widgets;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16__length1 = self->priv->widgets_length1;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp17_ = _tmp16_[i];
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				old_height = _tmp17_.height;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
				if (old_width > 0) {
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = TRUE;
#line 421 "LabelWithWidgets.c"
				} else {
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = old_height > 0;
#line 425 "LabelWithWidgets.c"
				}
#line 99 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp18_) {
#line 429 "LabelWithWidgets.c"
					gboolean _tmp19_ = FALSE;
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					if (old_width != width) {
#line 100 "../src/Widgets/LabelWithWidgets.vala"
						_tmp19_ = TRUE;
#line 435 "LabelWithWidgets.c"
					} else {
#line 100 "../src/Widgets/LabelWithWidgets.vala"
						_tmp19_ = old_height != height;
#line 439 "LabelWithWidgets.c"
					}
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					if (_tmp19_) {
#line 443 "LabelWithWidgets.c"
						TubaWidgetsLabelWithWidgetsLWWWidget* _tmp20_;
						gint _tmp20__length1;
						TubaWidgetsLabelWithWidgetsLWWWidget* _tmp21_;
						gint _tmp21__length1;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_ = self->priv->widgets;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20__length1 = self->priv->widgets_length1;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_[i].width = width;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_ = self->priv->widgets;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21__length1 = self->priv->widgets_length1;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_[i].height = height;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
						child_size_changed = TRUE;
#line 462 "LabelWithWidgets.c"
					}
				} else {
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp22_;
					gint _tmp22__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp23_;
					gint _tmp23__length1;
#line 107 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_ = self->priv->widgets;
#line 107 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22__length1 = self->priv->widgets_length1;
#line 107 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_[i].width = width;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = self->priv->widgets;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23__length1 = self->priv->widgets_length1;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_[i].height = height;
#line 110 "../src/Widgets/LabelWithWidgets.vala"
					child_size_changed = TRUE;
#line 483 "LabelWithWidgets.c"
				}
			}
		}
	}
#line 115 "../src/Widgets/LabelWithWidgets.vala"
	if (!child_size_changed) {
#line 116 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 492 "LabelWithWidgets.c"
	}
#line 119 "../src/Widgets/LabelWithWidgets.vala"
	_tmp24_ = pango_attr_list_new ();
#line 119 "../src/Widgets/LabelWithWidgets.vala"
	attrs = _tmp24_;
#line 120 "../src/Widgets/LabelWithWidgets.vala"
	index = 0;
#line 500 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 505 "LabelWithWidgets.c"
		{
			gboolean _tmp25_ = FALSE;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
			_tmp25_ = TRUE;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 512 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp27_;
				gint _tmp27__length1;
				const gchar* _tmp28_;
				PangoRectangle logical_rect = {0};
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp29_;
				gint _tmp29__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp30_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp31_;
				gint _tmp31__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp32_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp33_;
				gint _tmp33__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp34_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp35_;
				gint _tmp35__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp36_;
				PangoRectangle _tmp37_ = {0};
				PangoAttribute* shape = NULL;
				PangoRectangle _tmp38_;
				PangoRectangle _tmp39_;
				PangoAttribute* _tmp40_;
				PangoAttribute* _tmp41_;
				PangoAttribute* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				PangoAttrList* _tmp45_;
				PangoAttribute* _tmp46_;
				PangoAttribute* _tmp47_;
				gint _tmp48_;
				gint _tmp49_;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp25_) {
#line 545 "LabelWithWidgets.c"
					gint _tmp26_;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26_ = i;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp26_ + 1;
#line 551 "LabelWithWidgets.c"
				}
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				_tmp25_ = FALSE;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27_ = self->priv->widgets;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27__length1 = self->priv->widgets_length1;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp27__length1)) {
#line 122 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 563 "LabelWithWidgets.c"
				}
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28_ = self->priv->_label_text;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				index = string_index_of (_tmp28_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER, index);
#line 124 "../src/Widgets/LabelWithWidgets.vala"
				if (index < 0) {
#line 124 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 573 "LabelWithWidgets.c"
				}
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29_ = self->priv->widgets;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29__length1 = self->priv->widgets_length1;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = _tmp29_[i];
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_ = self->priv->widgets;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31__length1 = self->priv->widgets_length1;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp32_ = _tmp31_[i];
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33_ = self->priv->widgets;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33__length1 = self->priv->widgets_length1;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp34_ = _tmp33_[i];
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_ = self->priv->widgets;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35__length1 = self->priv->widgets_length1;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp36_ = _tmp35_[i];
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				memset (&_tmp37_, 0, sizeof (PangoRectangle));
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.x = 0;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.y = (-(_tmp30_.height - (_tmp32_.height / 4))) * PANGO_SCALE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.width = _tmp34_.width * PANGO_SCALE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.height = _tmp36_.height * PANGO_SCALE;
#line 126 "../src/Widgets/LabelWithWidgets.vala"
				logical_rect = _tmp37_;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp38_ = logical_rect;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp39_ = logical_rect;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp40_ = pango_attr_shape_new (&_tmp38_, &_tmp39_);
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				shape = _tmp40_;
#line 134 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_ = shape;
#line 134 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_->start_index = (guint) index;
#line 135 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_ = shape;
#line 135 "../src/Widgets/LabelWithWidgets.vala"
				_tmp43_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 135 "../src/Widgets/LabelWithWidgets.vala"
				_tmp44_ = _tmp43_;
#line 135 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_->end_index = (guint) (index + _tmp44_);
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp45_ = attrs;
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp46_ = shape;
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp47_ = pango_attribute_copy (_tmp46_);
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				pango_attr_list_insert (_tmp45_, _tmp47_);
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp48_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp49_ = _tmp48_;
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				index = index + _tmp49_;
#line 122 "../src/Widgets/LabelWithWidgets.vala"
				_pango_attribute_destroy0 (shape);
#line 647 "LabelWithWidgets.c"
			}
		}
	}
#line 141 "../src/Widgets/LabelWithWidgets.vala"
	_tmp50_ = self->label;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
	_tmp51_ = attrs;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_attributes (_tmp50_, _tmp51_);
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	_pango_attr_list_unref0 (attrs);
#line 659 "LabelWithWidgets.c"
}

static PangoLayoutRun*
_vala_PangoLayoutRun_copy (PangoLayoutRun* self)
{
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	return g_boxed_copy (pango_glyph_item_get_type (), self);
#line 667 "LabelWithWidgets.c"
}

static gpointer
__vala_PangoLayoutRun_copy0 (gpointer self)
{
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	return self ? _vala_PangoLayoutRun_copy (self) : NULL;
#line 675 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutRun_free (PangoLayoutRun* self)
{
#line 187 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_glyph_item_get_type (), self);
#line 683 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutIter_free (PangoLayoutIter* self)
{
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_layout_iter_get_type (), self);
#line 691 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gint _tmp0__length1;
	PangoLayoutIter* run_iter = NULL;
	GtkLabel* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutIter* _tmp3_;
	gint i = 0;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 145 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 145 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp0__length1 == 0) {
#line 145 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 714 "LabelWithWidgets.c"
	}
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = gtk_label_get_layout (_tmp1_);
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = pango_layout_get_iter (_tmp2_);
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	run_iter = _tmp3_;
#line 148 "../src/Widgets/LabelWithWidgets.vala"
	i = 0;
#line 150 "../src/Widgets/LabelWithWidgets.vala"
	while (TRUE) {
#line 728 "LabelWithWidgets.c"
		PangoLayoutRun* run = NULL;
		PangoLayoutIter* _tmp4_;
		PangoLayoutRun* _tmp5_;
		PangoLayoutRun* _tmp6_;
		PangoLayoutRun* _tmp7_;
		PangoLayoutIter* _tmp36_;
#line 151 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = run_iter;
#line 151 "../src/Widgets/LabelWithWidgets.vala"
		_tmp5_ = pango_layout_iter_get_run_readonly (_tmp4_);
#line 151 "../src/Widgets/LabelWithWidgets.vala"
		_tmp6_ = __vala_PangoLayoutRun_copy0 (_tmp5_);
#line 151 "../src/Widgets/LabelWithWidgets.vala"
		run = _tmp6_;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		_tmp7_ = run;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp7_ != NULL) {
#line 747 "LabelWithWidgets.c"
			GSList* extra_attrs = NULL;
			PangoLayoutRun* _tmp8_;
			PangoItem* _tmp9_;
			PangoAnalysis _tmp10_;
			GSList* _tmp11_;
			GSList* _tmp12_;
			gboolean has_shape_attr = FALSE;
			GSList* _tmp13_;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			_tmp8_ = run;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			_tmp9_ = ((PangoGlyphItem*) _tmp8_)->item;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			_tmp10_ = _tmp9_->analysis;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			_tmp11_ = _tmp10_.extra_attrs;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			_tmp12_ = g_slist_copy (_tmp11_);
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			extra_attrs = _tmp12_;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			has_shape_attr = FALSE;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
			_tmp13_ = extra_attrs;
#line 772 "LabelWithWidgets.c"
			{
				GSList* attr_collection = NULL;
				GSList* attr_it = NULL;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
				attr_collection = _tmp13_;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
				for (attr_it = attr_collection; attr_it != NULL; attr_it = attr_it->next) {
#line 780 "LabelWithWidgets.c"
					void* attr = NULL;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
					attr = attr_it->data;
#line 784 "LabelWithWidgets.c"
					{
						void* _tmp14_;
						PangoAttrShape* _tmp15_;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
						_tmp14_ = attr;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
						_tmp15_ = pango_attribute_as_shape ((PangoAttribute*) _tmp14_);
#line 156 "../src/Widgets/LabelWithWidgets.vala"
						if (_tmp15_ != NULL) {
#line 157 "../src/Widgets/LabelWithWidgets.vala"
							has_shape_attr = TRUE;
#line 158 "../src/Widgets/LabelWithWidgets.vala"
							break;
#line 798 "LabelWithWidgets.c"
						}
					}
				}
			}
#line 162 "../src/Widgets/LabelWithWidgets.vala"
			if (has_shape_attr) {
#line 805 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp16_;
				gint _tmp16__length1;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16_ = self->priv->widgets;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16__length1 = self->priv->widgets_length1;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
				if (i < _tmp16__length1) {
#line 814 "LabelWithWidgets.c"
					PangoRectangle logical_rect = {0};
					PangoLayoutIter* _tmp17_;
					PangoRectangle _tmp18_ = {0};
					PangoRectangle _tmp19_;
					PangoRectangle _tmp20_;
					gint offset_x = 0;
					gint offset_y = 0;
					GtkLabel* _tmp21_;
					gint _tmp22_ = 0;
					gint _tmp23_ = 0;
					GtkAllocation allocation = {0};
					PangoRectangle _tmp24_;
					PangoRectangle _tmp25_;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp26_;
					gint _tmp26__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp27_;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp28_;
					gint _tmp28__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp29_;
					GtkAllocation _tmp30_ = {0};
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp31_;
					gint _tmp31__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp32_;
					GtkWidget* _tmp33_;
					GtkAllocation _tmp34_;
					gint _tmp35_;
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					_tmp17_ = run_iter;
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					pango_layout_iter_get_run_extents (_tmp17_, NULL, &_tmp18_);
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect = _tmp18_;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = logical_rect;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect.x = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp19_.x, 0);
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20_ = logical_rect;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect.y = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp20_.y, 0);
#line 176 "../src/Widgets/LabelWithWidgets.vala"
					_tmp21_ = self->label;
#line 176 "../src/Widgets/LabelWithWidgets.vala"
					gtk_label_get_layout_offsets (_tmp21_, &_tmp22_, &_tmp23_);
#line 176 "../src/Widgets/LabelWithWidgets.vala"
					offset_x = _tmp22_;
#line 176 "../src/Widgets/LabelWithWidgets.vala"
					offset_y = _tmp23_;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp24_ = logical_rect;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp25_ = logical_rect;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26_ = self->priv->widgets;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26__length1 = self->priv->widgets_length1;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp27_ = _tmp26_[i];
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp28_ = self->priv->widgets;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp28__length1 = self->priv->widgets_length1;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp29_ = _tmp28_[i];
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					memset (&_tmp30_, 0, sizeof (GtkAllocation));
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.x = _tmp24_.x + offset_x;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.y = _tmp25_.y + offset_y;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.height = _tmp27_.height;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_.width = _tmp29_.width;
#line 178 "../src/Widgets/LabelWithWidgets.vala"
					allocation = _tmp30_;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_ = self->priv->widgets;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31__length1 = self->priv->widgets_length1;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp32_ = _tmp31_[i];
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp33_ = _tmp32_.widget;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp34_ = allocation;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					gtk_widget_size_allocate (_tmp33_, &_tmp34_, -1);
#line 185 "../src/Widgets/LabelWithWidgets.vala"
					_tmp35_ = i;
#line 185 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp35_ + 1;
#line 907 "LabelWithWidgets.c"
				} else {
#line 187 "../src/Widgets/LabelWithWidgets.vala"
					(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 187 "../src/Widgets/LabelWithWidgets.vala"
					__vala_PangoLayoutRun_free0 (run);
#line 187 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 915 "LabelWithWidgets.c"
				}
			}
#line 152 "../src/Widgets/LabelWithWidgets.vala"
			(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 920 "LabelWithWidgets.c"
		}
#line 192 "../src/Widgets/LabelWithWidgets.vala"
		_tmp36_ = run_iter;
#line 192 "../src/Widgets/LabelWithWidgets.vala"
		if (!pango_layout_iter_next_run (_tmp36_)) {
#line 193 "../src/Widgets/LabelWithWidgets.vala"
			__vala_PangoLayoutRun_free0 (run);
#line 193 "../src/Widgets/LabelWithWidgets.vala"
			break;
#line 930 "LabelWithWidgets.c"
		}
#line 150 "../src/Widgets/LabelWithWidgets.vala"
		__vala_PangoLayoutRun_free0 (run);
#line 934 "LabelWithWidgets.c"
	}
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	__vala_PangoLayoutIter_free0 (run_iter);
#line 938 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                    gint width,
                                                    gint height,
                                                    gint baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
#line 198 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 199 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 199 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp0_, width, height, baseline, NULL);
#line 200 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_children (self);
#line 957 "LabelWithWidgets.c"
}

static GtkSizeRequestMode
tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkSizeRequestMode result;
#line 203 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 204 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 204 "../src/Widgets/LabelWithWidgets.vala"
	result = gtk_widget_get_request_mode ((GtkWidget*) _tmp0_);
#line 204 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 974 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                              GtkOrientation orientation,
                                              gint for_size,
                                              gint* minimum,
                                              gint* natural,
                                              gint* minimum_baseline,
                                              gint* natural_baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _vala_minimum_baseline = 0;
	gint _vala_natural_baseline = 0;
	GtkLabel* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 215 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum = _tmp1_;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural = _tmp2_;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum_baseline = _tmp3_;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural_baseline = _tmp4_;
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum) {
#line 207 "../src/Widgets/LabelWithWidgets.vala"
		*minimum = _vala_minimum;
#line 1016 "LabelWithWidgets.c"
	}
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	if (natural) {
#line 207 "../src/Widgets/LabelWithWidgets.vala"
		*natural = _vala_natural;
#line 1022 "LabelWithWidgets.c"
	}
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum_baseline) {
#line 207 "../src/Widgets/LabelWithWidgets.vala"
		*minimum_baseline = _vala_minimum_baseline;
#line 1028 "LabelWithWidgets.c"
	}
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	if (natural_baseline) {
#line 207 "../src/Widgets/LabelWithWidgets.vala"
		*natural_baseline = _vala_natural_baseline;
#line 1034 "LabelWithWidgets.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1057 "LabelWithWidgets.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1061 "LabelWithWidgets.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1067 "LabelWithWidgets.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1071 "LabelWithWidgets.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1075 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 1083 "LabelWithWidgets.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1111 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 1120 "LabelWithWidgets.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1134 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 1143 "LabelWithWidgets.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 1157 "LabelWithWidgets.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1166 "LabelWithWidgets.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 1175 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self)
{
	gchar* old_label = NULL;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* new_label = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 226 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 227 "../src/Widgets/LabelWithWidgets.vala"
	old_label = _tmp3_;
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = self->priv->_text;
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = tuba_widgets_label_with_widgets_get_placeholder (self);
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp6_ = _tmp5_;
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	_tmp7_ = string_replace (_tmp4_, _tmp6_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 228 "../src/Widgets/LabelWithWidgets.vala"
	new_label = _tmp7_;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	_tmp8_ = old_label;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	_tmp9_ = new_label;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (_tmp8_, _tmp9_) != 0) {
#line 1221 "LabelWithWidgets.c"
		GtkLabel* _tmp10_;
		GtkLabel* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GtkLabel* _tmp14_;
		const gchar* _tmp15_;
		GtkLabel* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 231 "../src/Widgets/LabelWithWidgets.vala"
		_tmp10_ = self->label;
#line 231 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap (_tmp10_, TRUE);
#line 232 "../src/Widgets/LabelWithWidgets.vala"
		_tmp11_ = self->label;
#line 232 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap_mode (_tmp11_, PANGO_WRAP_WORD_CHAR);
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		_tmp12_ = new_label;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_text);
#line 234 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_text = _tmp13_;
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		_tmp14_ = self->label;
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		_tmp15_ = self->priv->_text;
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_label (_tmp14_, _tmp15_);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
		_tmp16_ = self->label;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
		_tmp17_ = gtk_label_get_text (_tmp16_);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_label_text);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_label_text = _tmp18_;
#line 237 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1265 "LabelWithWidgets.c"
	}
#line 226 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (new_label);
#line 226 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (old_label);
#line 1271 "LabelWithWidgets.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	return self ? g_object_ref (self) : NULL;
#line 1279 "LabelWithWidgets.c"
}

static void
_vala_array_add26 (TubaWidgetsLabelWithWidgetsLWWWidget* * array,
                   gint* length,
                   gint* size,
                   const TubaWidgetsLabelWithWidgetsLWWWidget* value)
{
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 242 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 242 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (TubaWidgetsLabelWithWidgetsLWWWidget, *array, *size);
#line 1294 "LabelWithWidgets.c"
	}
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = *value;
#line 1298 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget* child)
{
	GtkWidget* _tmp0_;
	TubaWidgetsLabelWithWidgetsLWWWidget _tmp1_ = {0};
#line 241 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (child);
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	memset (&_tmp1_, 0, sizeof (TubaWidgetsLabelWithWidgetsLWWWidget));
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (_tmp1_.widget);
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.widget = _tmp0_;
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.width = 0;
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.height = 0;
#line 242 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add26 (&self->priv->widgets, &self->priv->widgets_length1, &self->priv->_widgets_size_, &_tmp1_);
#line 247 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent (child, (GtkWidget*) self);
#line 248 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1329 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                  const gchar* t_text,
                                                                  GtkWidget** t_widgets,
                                                                  gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (t_text != NULL, NULL);
#line 252 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 1343 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1355 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1359 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp0_;
#line 255 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = widget;
#line 255 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp0_);
#line 1366 "LabelWithWidgets.c"
			}
		}
	}
#line 258 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_set_text (self, t_text);
#line 251 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1374 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                            GtkWidget** t_widgets,
                                                            gint t_widgets_length1)
{
#line 251 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct_with_label_and_widgets (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, t_text, t_widgets, t_widgets_length1);
#line 1384 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget** t_widgets,
                                              gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gint _tmp0__length1;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp7_;
#line 261 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 1401 "LabelWithWidgets.c"
	{
		TubaWidgetsLabelWithWidgetsLWWWidget* child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp0_;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp0__length1;
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 1413 "LabelWithWidgets.c"
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp1_;
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp2_ = {0};
			TubaWidgetsLabelWithWidgetsLWWWidget child = {0};
#line 262 "../src/Widgets/LabelWithWidgets.vala"
			_tmp1_ = child_collection[child_it];
#line 262 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_copy (&_tmp1_, &_tmp2_);
#line 262 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp2_;
#line 1423 "LabelWithWidgets.c"
			{
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp3_;
				GtkWidget* _tmp4_;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp5_;
				GtkWidget* _tmp6_;
#line 263 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 263 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = _tmp3_.widget;
#line 263 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp4_);
#line 264 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = child;
#line 264 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = _tmp5_.widget;
#line 264 "../src/Widgets/LabelWithWidgets.vala"
				g_signal_emit_by_name (_tmp6_, "destroy");
#line 262 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_lww_widget_destroy (&child);
#line 1443 "LabelWithWidgets.c"
			}
		}
	}
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	_tmp7_ = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 0);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (self->priv->widgets, self->priv->widgets_length1), NULL);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp7_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 1457 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1469 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1473 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp8_;
#line 268 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = widget;
#line 268 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp8_);
#line 1480 "LabelWithWidgets.c"
			}
		}
	}
}

static void
tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self)
{
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 1491 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 1496 "LabelWithWidgets.c"
		{
			gboolean _tmp0_ = FALSE;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
			_tmp0_ = TRUE;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 1503 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp2_;
				gint _tmp2__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp3_;
				gint _tmp3__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp4_;
				gint _tmp4__length1;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp0_) {
#line 1512 "LabelWithWidgets.c"
					gint _tmp1_;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
					_tmp1_ = i;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp1_ + 1;
#line 1518 "LabelWithWidgets.c"
				}
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = FALSE;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = self->priv->widgets;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2__length1 = self->priv->widgets_length1;
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp2__length1)) {
#line 273 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1530 "LabelWithWidgets.c"
				}
#line 274 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widgets;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widgets_length1;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_[i].width = 0;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = self->priv->widgets;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4__length1 = self->priv->widgets_length1;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_[i].height = 0;
#line 1544 "LabelWithWidgets.c"
			}
		}
	}
#line 277 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 278 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 1552 "LabelWithWidgets.c"
}

static gint
tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                              gint d,
                                              gint a)
{
	gint result;
#line 281 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
	result = (d + a) >> 10;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1567 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                GtkBuilder* builder,
                                                GObject* child,
                                                const gchar* type)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (builder != NULL);
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 286 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()) ? ((GtkWidget*) child) : NULL);
#line 286 "../src/Widgets/LabelWithWidgets.vala"
	widget = _tmp0_;
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = widget;
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp1_ != NULL) {
#line 1594 "LabelWithWidgets.c"
		GtkWidget* _tmp2_;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
		_tmp2_ = widget;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_append_child (self, _tmp2_);
#line 1600 "LabelWithWidgets.c"
	} else {
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 290 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 290 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = _tmp3_;
#line 290 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) _tmp4_, builder, child, type);
#line 1610 "LabelWithWidgets.c"
	}
#line 293 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), builder, child, type);
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (widget);
#line 1616 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct (GType object_type)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1627 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new (void)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS);
#line 1635 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_placeholder;
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1651 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 25 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp0_;
#line 27 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 25 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY]);
#line 1671 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_text;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1687 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 37 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp0_;
#line 39 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify ((GObject*) _tmp1_, "label");
#line 37 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY]);
#line 1712 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 46 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_use_markup;
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1725 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 49 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/LabelWithWidgets.vala"
	if (self->priv->_use_markup == value) {
#line 50 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 1739 "LabelWithWidgets.c"
	}
#line 52 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = value;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, self->priv->_use_markup);
#line 49 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY]);
#line 1749 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_single_line_mode (_tmp0_);
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1771 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                      gboolean value)
{
	GtkLabel* _tmp0_;
#line 300 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 300 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_single_line_mode (_tmp0_, value);
#line 300 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY]);
#line 1787 "LabelWithWidgets.c"
}

gfloat
tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_xalign (_tmp0_);
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 304 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1809 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                            gfloat value)
{
	GtkLabel* _tmp0_;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, value);
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY]);
#line 1825 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1847 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_selectable (_tmp0_, value);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY]);
#line 1863 "LabelWithWidgets.c"
}

gint
tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self)
{
	gint result;
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_lines (_tmp0_);
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1885 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                           gint value)
{
	GtkLabel* _tmp0_;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_lines (_tmp0_, value);
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY]);
#line 1901 "LabelWithWidgets.c"
}

GtkJustification
tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self)
{
	GtkJustification result;
	GtkLabel* _tmp0_;
	GtkJustification _tmp1_;
	GtkJustification _tmp2_;
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_justify (_tmp0_);
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1923 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                             GtkJustification value)
{
	GtkLabel* _tmp0_;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_justify (_tmp0_, value);
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY]);
#line 1939 "LabelWithWidgets.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__STRING) (gpointer data1, const char* arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (return_value != NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (n_param_values == 2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = closure->data;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = param_values->data[0].v_pointer;
#line 1967 "LabelWithWidgets.c"
	} else {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = param_values->data[0].v_pointer;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = closure->data;
#line 1973 "LabelWithWidgets.c"
	}
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	callback = (GMarshalFunc_BOOLEAN__STRING) (marshal_data ? marshal_data : cc->callback);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	v_return = callback (data1, g_value_get_string (param_values + 1), data2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_value_set_boolean (return_value, v_return);
#line 1981 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_copy (const TubaWidgetsLabelWithWidgetsLWWWidget* self,
                                                 TubaWidgetsLabelWithWidgetsLWWWidget* dest)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (*self).widget;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 ((*dest).widget);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).widget = _tmp1_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).height = (*self).height;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).width = (*self).width;
#line 2002 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_destroy (TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 ((*self).widget);
#line 2010 "LabelWithWidgets.c"
}

static TubaWidgetsLabelWithWidgetsLWWWidget*
tuba_widgets_label_with_widgets_lww_widget_dup (const TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* dup;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	dup = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 1);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_lww_widget_copy (self, dup);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	return dup;
#line 2023 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_free (TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_lww_widget_destroy (self);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	g_free (self);
#line 2033 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_lww_widget_get_type_once (void)
{
	GType tuba_widgets_label_with_widgets_lww_widget_type_id;
	tuba_widgets_label_with_widgets_lww_widget_type_id = g_boxed_type_register_static ("TubaWidgetsLabelWithWidgetsLWWWidget", (GBoxedCopyFunc) tuba_widgets_label_with_widgets_lww_widget_dup, (GBoxedFreeFunc) tuba_widgets_label_with_widgets_lww_widget_free);
	return tuba_widgets_label_with_widgets_lww_widget_type_id;
}

static GType
tuba_widgets_label_with_widgets_lww_widget_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_lww_widget_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_lww_widget_type_id__once)) {
		GType tuba_widgets_label_with_widgets_lww_widget_type_id;
		tuba_widgets_label_with_widgets_lww_widget_type_id = tuba_widgets_label_with_widgets_lww_widget_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_lww_widget_type_id__once, tuba_widgets_label_with_widgets_lww_widget_type_id);
	}
	return tuba_widgets_label_with_widgets_lww_widget_type_id__once;
}

static gboolean
_tuba_widgets_label_with_widgets___lambda26_ (TubaWidgetsLabelWithWidgets* self,
                                              const gchar* url)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_emit (self, tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL], 0, url, &_tmp0_);
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2070 "LabelWithWidgets.c"
}

static gboolean
__tuba_widgets_label_with_widgets___lambda26__gtk_label_activate_link (GtkLabel* _sender,
                                                                       const gchar* uri,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuba_widgets_label_with_widgets___lambda26_ ((TubaWidgetsLabelWithWidgets*) self, uri);
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2082 "LabelWithWidgets.c"
}

static GObject *
tuba_widgets_label_with_widgets_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
#line 59 "../src/Widgets/LabelWithWidgets.vala"
	parent_class = G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class);
#line 59 "../src/Widgets/LabelWithWidgets.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap (_tmp0_, TRUE);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap_mode (_tmp0_, PANGO_WRAP_WORD_CHAR);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, 0.0f);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, FALSE);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_NONE);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	g_object_ref_sink (_tmp0_);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	self->label = _tmp0_;
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp1_, (GtkWidget*) self);
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->label;
#line 72 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_connect_object (_tmp2_, "activate-link", (GCallback) __tuba_widgets_label_with_widgets___lambda26__gtk_label_activate_link, self, 0);
#line 59 "../src/Widgets/LabelWithWidgets.vala"
	return obj;
#line 2132 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_class_init (TubaWidgetsLabelWithWidgetsClass * klass,
                                            gpointer klass_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_type_class_adjust_private_offset (klass, &TubaWidgetsLabelWithWidgets_private_offset);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) tuba_widgets_label_with_widgets_real_size_allocate;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) tuba_widgets_label_with_widgets_real_get_request_mode;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) tuba_widgets_label_with_widgets_real_measure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuba_widgets_label_with_widgets_get_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuba_widgets_label_with_widgets_set_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->constructor = tuba_widgets_label_with_widgets_constructor;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->finalize = tuba_widgets_label_with_widgets_finalize;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY] = g_param_spec_string ("placeholder", "placeholder", "placeholder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY] = g_param_spec_boolean ("use-markup", "use-markup", "use-markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY] = g_param_spec_boolean ("single-line-mode", "single-line-mode", "single-line-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY] = g_param_spec_int ("lines", "lines", "lines", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY] = g_param_spec_enum ("justify", "justify", "justify", gtk_justification_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL] = g_signal_new ("activate-link", TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__STRING, G_TYPE_BOOLEAN, 1, G_TYPE_STRING);
#line 2175 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                              gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) tuba_widgets_label_with_widgets_real_add_child;
#line 2186 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_accessible_interface_init (GtkAccessibleInterface * iface,
                                                               gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = g_type_interface_peek_parent (iface);
#line 2195 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_instance_init (TubaWidgetsLabelWithWidgets * self,
                                               gpointer klass)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self->priv = tuba_widgets_label_with_widgets_get_instance_private (self);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 0);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp0_;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = g_strdup ("<widget>");
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp1_;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = g_strdup ("");
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_label_text = _tmp2_;
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup ("");
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp3_;
#line 44 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = FALSE;
#line 2230 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_finalize (GObject * obj)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp1_;
	gint _tmp1__length1;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 76 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->priv->widgets;
#line 76 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1__length1 = self->priv->widgets_length1;
#line 2250 "LabelWithWidgets.c"
	{
		TubaWidgetsLabelWithWidgetsLWWWidget* child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 76 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp1_;
#line 76 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp1__length1;
#line 76 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 2262 "LabelWithWidgets.c"
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp2_;
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp3_ = {0};
			TubaWidgetsLabelWithWidgetsLWWWidget child = {0};
#line 76 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = child_collection[child_it];
#line 76 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_copy (&_tmp2_, &_tmp3_);
#line 76 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp3_;
#line 2272 "LabelWithWidgets.c"
			{
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp4_;
				GtkWidget* _tmp5_;
#line 77 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = child;
#line 77 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = _tmp4_.widget;
#line 77 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp5_);
#line 76 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_lww_widget_destroy (&child);
#line 2284 "LabelWithWidgets.c"
			}
		}
	}
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (self->priv->widgets, self->priv->widgets_length1), NULL);
#line 18 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_label_text);
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class)->finalize (obj);
#line 2300 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TubaWidgetsLabelWithWidgetsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_widgets_label_with_widgets_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaWidgetsLabelWithWidgets), 0, (GInstanceInitFunc) tuba_widgets_label_with_widgets_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_accessible_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_accessible_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuba_widgets_label_with_widgets_type_id;
	tuba_widgets_label_with_widgets_type_id = g_type_register_static (gtk_widget_get_type (), "TubaWidgetsLabelWithWidgets", &g_define_type_info, 0);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_accessible_get_type (), &gtk_accessible_info);
	TubaWidgetsLabelWithWidgets_private_offset = g_type_add_instance_private (tuba_widgets_label_with_widgets_type_id, sizeof (TubaWidgetsLabelWithWidgetsPrivate));
	return tuba_widgets_label_with_widgets_type_id;
}

GType
tuba_widgets_label_with_widgets_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_type_id__once)) {
		GType tuba_widgets_label_with_widgets_type_id;
		tuba_widgets_label_with_widgets_type_id = tuba_widgets_label_with_widgets_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_type_id__once, tuba_widgets_label_with_widgets_type_id);
	}
	return tuba_widgets_label_with_widgets_type_id__once;
}

static void
_vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_placeholder (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_use_markup (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_single_line_mode (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_float (value, tuba_widgets_label_with_widgets_get_xalign (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_selectable (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_int (value, tuba_widgets_label_with_widgets_get_lines (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_enum (value, tuba_widgets_label_with_widgets_get_justify (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2387 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2393 "LabelWithWidgets.c"
	}
}

static void
_vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_placeholder (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_text (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_use_markup (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_single_line_mode (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_xalign (self, g_value_get_float (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_selectable (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_lines (self, g_value_get_int (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_justify (self, g_value_get_enum (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2455 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2461 "LabelWithWidgets.c"
	}
}

